#include "extension.h"

CCSSpeedMods g_Interface;
SMEXT_LINK(&g_Interface);

IForward *g_pGetPlayerMaxSpeed = NULL;
IGameConfig *g_pGameConf = NULL;
IServerGameEnts *gameents = NULL;
CDetour *DGetPlayerMaxSpeed;

DETOUR_DECL_MEMBER0(GetPlayerMaxSpeed, float)
{
	int client = engine->IndexOfEdict(gameents->BaseEntityToEdict(reinterpret_cast<CBaseEntity *>(this)));
	float Return = DETOUR_MEMBER_CALL(GetPlayerMaxSpeed)();
	g_pGetPlayerMaxSpeed->PushCell(client);
	g_pGetPlayerMaxSpeed->PushFloatByRef(&Return);
	g_pGetPlayerMaxSpeed->Execute(NULL);
	return Return;
}

bool CCSSpeedMods::SDK_OnLoad(char *error, size_t maxlength, bool late)
{
	g_pGetPlayerMaxSpeed = forwards->CreateForward("GetPlayerMaxSpeed", ET_Ignore, 2, NULL, Param_Cell, Param_FloatByRef);
	char conf_error[255] = "";
	if(!gameconfs->LoadGameConfigFile("cssspeedmod", &g_pGameConf, conf_error, sizeof(conf_error)))
	{
		if(conf_error[0])
			snprintf(error, maxlength, "Could not read cssspeedmod.txt: %s", conf_error);
		
		return false;
	}
	CDetourManager::Init(g_pSM->GetScriptingEngine(), g_pGameConf);
	DGetPlayerMaxSpeed = DETOUR_CREATE_MEMBER(GetPlayerMaxSpeed, "CCSPlayer::GetPlayerMaxSpeed");
	DGetPlayerMaxSpeed->EnableDetour();
	return true;
}

void CCSSpeedMods::SDK_OnUnload()
{
	forwards->ReleaseForward(g_pGetPlayerMaxSpeed);
	gameconfs->CloseGameConfigFile(g_pGameConf);
	DGetPlayerMaxSpeed->Destroy();
}

bool CCSSpeedMods::SDK_OnMetamodLoad(ISmmAPI *ismm, char *error, size_t maxlen, bool late)
{
	GET_V_IFACE_CURRENT(GetServerFactory, gameents, IServerGameEnts, INTERFACEVERSION_SERVERGAMEENTS);
	return true;
}